SystemOrganization addCategory: #TusLibros!

Object subclass: #Book
	instanceVariableNames: 'id price'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibros'!

!Book class methodsFor: 'as yet unclassified' stamp: 'EzequielBarrios 6/9/2013 20:10'!
id: aBookId andPrice: aPrice 

	^ (self new) book: aBookId price: aPrice.
	 ! !

!Book methodsFor: 'as yet unclassified' stamp: 'EzequielBarrios 6/9/2013 20:48'!
= aBook

	^(self id = aBook id) and: (self price = aBook price)! !

!Book methodsFor: 'as yet unclassified' stamp: 'EzequielBarrios 6/9/2013 20:49'!
book: aBookID price: aPrice

	super initialize.
	id:= aBookID.
	price:= aPrice.
! !

!Book methodsFor: 'as yet unclassified' stamp: 'EzequielBarrios 6/9/2013 20:09'!
id

	^id! !

!Book methodsFor: 'as yet unclassified' stamp: 'EzequielBarrios 6/9/2013 19:57'!
price

	^price! !

Object subclass: #Cashier
	instanceVariableNames: 'purchaseBook merchantProcesor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibros'!

!Cashier class methodsFor: 'as yet unclassified' stamp: 'EzequielBarrios 6/9/2013 16:29'!
aExpiredCreditCardCantBuyAnything
	^ 'La tarjeta de crdito est vencida.'! !

!Cashier class methodsFor: 'as yet unclassified' stamp: 'EzequielBarrios 5/29/2013 21:39'!
checkingOutAnEmptyCartErrorDescription
	^ 'No se puede realizar el cobro de un carrito vaco.'! !

!Cashier class methodsFor: 'as yet unclassified' stamp: 'EzequielBarrios 6/10/2013 18:21'!
create: aMP
	
	^(self new) initialize: aMP! !

!Cashier class methodsFor: 'as yet unclassified' stamp: 'EzequielBarrios 6/9/2013 22:49'!
theNameIsInvalid
	^ 'El nombre es invlido'! !

!Cashier methodsFor: 'as yet unclassified' stamp: 'EzequielBarrios 6/10/2013 18:28'!
checkOut: aShoppingCart withCreditCard: aCreditCardNumber andExpirationDate: anExpirationDate belongingTo: aName

	|aSale|

	(aShoppingCart isEmpty) ifTrue: [self error: self class checkingOutAnEmptyCartErrorDescription]. 	
	(Date today > anExpirationDate ) ifTrue: [ self error: self class aExpiredCreditCardCantBuyAnything].
	(aName size > 30) ifTrue: [ self error: self class theNameIsInvalid ].
	
	aSale:= Sale new.
	aShoppingCart productsBag do: [ :a |
		aSale add: (Book id: a andPrice: (aShoppingCart priceOff: a)) withOccurrencies: 1 ].
	purchaseBook:= purchaseBook copyWith: aSale.
	merchantProcesor charge: aSale total to: aName withCreditCard: aCreditCardNumber thatExpire: anExpirationDate ! !

!Cashier methodsFor: 'as yet unclassified' stamp: 'EzequielBarrios 6/9/2013 23:24'!
initialize
	purchaseBook := OrderedCollection new.
	merchantProcesor := MPInterface new.! !

!Cashier methodsFor: 'as yet unclassified' stamp: 'EzequielBarrios 6/10/2013 18:27'!
initialize: aMPInterface
	
	purchaseBook := #().
	merchantProcesor := aMPInterface .! !

!Cashier methodsFor: 'as yet unclassified' stamp: 'EzequielBarrios 6/9/2013 20:54'!
purchaseBook

	^ purchaseBook! !

!Cashier methodsFor: 'as yet unclassified' stamp: 'EzequielBarrios 6/3/2013 20:45'!
purchaseCount
	^ purchaseBook size.! !

Object subclass: #MPInterface
	instanceVariableNames: 'merchatProcesor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibros'!

!MPInterface class methodsFor: 'as yet unclassified' stamp: 'EzequielBarrios 6/12/2013 11:15'!
create: aMP

	^self new initialize: aMP.! !

!MPInterface methodsFor: 'as yet unclassified' stamp: 'EzequielBarrios 6/12/2013 11:44'!
charge: anAmount to: aName withCreditCard: aCreditCardNumber thatExpire: aDate
	"comment stating purpose of message"

	|link code|
	link:= 'https://merchant.com/debit'.
	link:= link, '?creditCardNumber=', aCreditCardNumber asString .
	link:= link, '&creditCardExpiration=', (self formatDate: aDate).
	link:= link, '&creditCardOwner=', (self formatName: aName).
	link:= link, 	'&transactionAmount=', (anAmount printShowingDecimalPlaces: 2) asString.
	code:=merchatProcesor validate: link.
	^ self interpretingCode: code.! !

!MPInterface methodsFor: 'as yet unclassified' stamp: 'EzequielBarrios 6/10/2013 21:14'!
formatDate: aDate 
	
	|string|
	string:= aDate asDateAndTime month asString, aDate asDateAndTime year asString .
	(string size = 5) ifTrue: [ string:= '0',string ].
	^string! !

!MPInterface methodsFor: 'as yet unclassified' stamp: 'EzequielBarrios 6/10/2013 21:45'!
formatName: aName

	|result chain|
	chain:= aName substrings asOrderedCollection .
	result:= '', chain removeFirst asUppercase .
	[ chain size ~=  0 ] whileTrue: [ result:= result, '%20', chain removeFirst asUppercase ].
	^result
	! !

!MPInterface methodsFor: 'as yet unclassified' stamp: 'EzequielBarrios 6/12/2013 11:15'!
initialize: aMP

	merchatProcesor:= aMP! !

!MPInterface methodsFor: 'as yet unclassified' stamp: 'EzequielBarrios 6/12/2013 12:09'!
interpretingCode: aCode

	((aCode first: 3 )= '400') ifTrue: [ self error: 'bad request' ]! !

Object subclass: #Sale
	instanceVariableNames: 'products'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibros'!

!Sale methodsFor: 'as yet unclassified' stamp: 'EzequielBarrios 6/9/2013 20:13'!
add: aBook withOccurrencies: aNumber

	products add: aBook withOccurrences: aNumber! !

!Sale methodsFor: 'as yet unclassified' stamp: 'EzequielBarrios 6/9/2013 19:48'!
initialize
	
	products:= Bag new.! !

!Sale methodsFor: 'as yet unclassified' stamp: 'EzequielBarrios 6/9/2013 21:18'!
total
	
	|total|
	
	total:= 0.
	products do: [ :a | total:= total + a price ].
	total := total*100.
	total :=total truncated .
	^ (total/100) asFloat.
	
	! !

Object subclass: #ShoppingCart
	instanceVariableNames: 'catalog productsBag'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibros'!

!ShoppingCart class methodsFor: 'as yet unclassified' stamp: 'EzequielBarrios 5/29/2013 20:45'!
addingAProductNotInCatalogErrorDescription
	^ 'No se puede agregar un producto que no exista en el catlogo'.! !

!ShoppingCart class methodsFor: 'as yet unclassified' stamp: 'EzequielBarrios 5/29/2013 20:04'!
addingNonPositiveQuantityErrorDescription
	^ 'No se puede agregar al carrito una cantidad menor que 1'.! !

!ShoppingCart methodsFor: 'as yet unclassified' stamp: 'EzequielBarrios 5/29/2013 21:17'!
addProduct: aProductID
	(catalog includesKey: aProductID) ifTrue: [productsBag add: aProductID] ifFalse: [self error: self class addingAProductNotInCatalogErrorDescription ].! !

!ShoppingCart methodsFor: 'as yet unclassified' stamp: 'EzequielBarrios 5/29/2013 20:37'!
containsProduct: aProductID
	^ productsBag includes: aProductID "Association: (Association new key: aProductID value: aQuantity)."! !

!ShoppingCart methodsFor: 'as yet unclassified' stamp: 'EzequielBarrios 6/3/2013 21:12'!
getShoppingList
	"Devuelve la cantidad de items en el carrito"
	| aShoppingList |
	aShoppingList := Bag new.
	productsBag do: [ :aProduct | aShoppingList add: (Association new key: aProduct value: ( catalog at: aProduct )) ]
	! !

!ShoppingCart methodsFor: 'as yet unclassified' stamp: 'EzequielBarrios 5/29/2013 20:55'!
initializeWithCatalog: aPublishersCatalog
	super initialize.
	productsBag := Bag new.
	catalog := aPublishersCatalog.! !

!ShoppingCart methodsFor: 'as yet unclassified' stamp: 'EzequielBarrios 5/29/2013 21:39'!
isEmpty
	"Devuelve la cantidad de items en el carrito"
	^ productsBag isEmpty! !

!ShoppingCart methodsFor: 'as yet unclassified' stamp: 'EzequielBarrios 6/9/2013 20:45'!
priceOff: aProduct
	"Devuelve la cantidad de items en el carrito"
	^ catalog at: aProduct! !

!ShoppingCart methodsFor: 'as yet unclassified' stamp: 'EzequielBarrios 6/9/2013 20:52'!
productsBag

	^ productsBag! !

!ShoppingCart methodsFor: 'as yet unclassified' stamp: 'EzequielBarrios 5/29/2013 20:20'!
size
	"Devuelve la cantidad de items en el carrito"
	^ productsBag size! !

TestCase subclass: #TusLibrosTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibros'!

!TusLibrosTests methodsFor: 'cosas' stamp: 'EzequielBarrios 6/3/2013 20:55'!
aNonEmptyBookCatalog
	| aBookCatalog |
	aBookCatalog := Dictionary new.
	aBookCatalog add:  (Association new key: 1 value: 10.4).
	aBookCatalog add:  (Association new key: 2 value: 20.8).
	aBookCatalog add:  (Association new key: 3 value: 31.2).
	aBookCatalog add:  (Association new key: 4 value: 41.6).
	aBookCatalog add:  (Association new key: 5 value: 52.0).
	aBookCatalog add:  (Association new key: 6 value: 62.4).
	aBookCatalog add:  (Association new key: 7 value: 72.8).
	aBookCatalog add:  (Association new key: 8 value: 83.2).
	aBookCatalog add:  (Association new key: 9 value: 93.6).
	^ aBookCatalog! !

!TusLibrosTests methodsFor: 'cosas' stamp: 'EzequielBarrios 6/3/2013 20:56'!
aNonEmptyCart
	| aBookCart aBookCatalog |
	aBookCatalog := self aNonEmptyBookCatalog.
	aBookCart := ShoppingCart new initializeWithCatalog: aBookCatalog.
	aBookCart addProduct: 1.
	aBookCart addProduct: 3.
	aBookCart addProduct: 1.
	aBookCart addProduct: 5.
	aBookCart addProduct: 1.
	aBookCart addProduct: 7.
	^ aBookCart! !

!TusLibrosTests methodsFor: 'cosas' stamp: 'EzequielBarrios 5/29/2013 21:09'!
anEmptyBookCart
	^ ShoppingCart new initializeWithCatalog: self anEmptyPublisherCatalog! !

!TusLibrosTests methodsFor: 'cosas' stamp: 'EzequielBarrios 5/29/2013 21:14'!
anEmptyPublisherCatalog
	^ Dictionary new.! !

!TusLibrosTests methodsFor: 'methods' stamp: 'EzequielBarrios 6/10/2013 18:31'!
charge: anAmount to: aName withCreditCard: aCreditCardNumber thatExpire: aDate 
	
	self assert: (anAmount isKindOf: Number).
	self assert: (aName isKindOf: String).
	self assert: (aCreditCardNumber isKindOf: Number).
	self assert: (aDate isKindOf: Date).
	! !

!TusLibrosTests methodsFor: 'as yet unclassified' stamp: 'EzequielBarrios 5/29/2013 19:56'!
test01CartShouldBeEmptyAfterCreation
	"Luego de crear el carrito el mismo debe estar vaco"	
	self assert: self anEmptyBookCart size=0! !

!TusLibrosTests methodsFor: 'as yet unclassified' stamp: 'EzequielBarrios 5/29/2013 21:20'!
test02AfterAddingABookCartMustHaveThatBook

	|aBookID aBookPrice aBookCart aBookCatalog|
	aBookID := 1.
	aBookPrice := 10.4.
	aBookCatalog := self anEmptyPublisherCatalog.
	aBookCatalog add:  (Association new key: aBookID value: aBookPrice).
	aBookCart := ShoppingCart new initializeWithCatalog: aBookCatalog.
	aBookCart addProduct: aBookID.
	self assert: (aBookCart containsProduct: aBookID).
	self assert: aBookCart size = 1.

	! !

!TusLibrosTests methodsFor: 'as yet unclassified' stamp: 'EzequielBarrios 5/29/2013 21:55'!
test03AddingABookFromAnotherPublisherShouldRaiseAnException
	"No puedo agregar libros que no sean de mi editorial"
	|aBookID aBookCart |
	aBookID := 1.
	aBookCart := self anEmptyBookCart .
	self
		should: [ aBookCart addProduct: aBookID ]
		raise: Error
		withExceptionDo: [ :anError |
			self assert: anError messageText = ShoppingCart addingAProductNotInCatalogErrorDescription. 
			self assert: aBookCart isEmpty].
	! !

!TusLibrosTests methodsFor: 'as yet unclassified' stamp: 'EzequielBarrios 6/9/2013 22:48'!
test04CheckingOutAnEmptyCartShouldRaiseAnError
	"No se puede cobrar un carrito vaco"

	| aCashier |
	aCashier := Cashier new.
	self
		should: [ 
			aCashier
				checkOut: self anEmptyBookCart
				withCreditCard: 1000
				andExpirationDate: Date tomorrow
				belongingTo: nil ]
		raise: Error
		withExceptionDo: [ :anError | 
			self assert: anError messageText = Cashier checkingOutAnEmptyCartErrorDescription.
			self assert: aCashier purchaseCount = 0 ]! !

!TusLibrosTests methodsFor: 'as yet unclassified' stamp: 'EzequielBarrios 6/9/2013 22:58'!
test05ALongNameShouldBeRaiseAnError
	"No se puede cobrar a una tarjeta de crdito vencida."

	self
		should: [ 
			Cashier new
				checkOut: self aNonEmptyCart
				withCreditCard: 1000
				andExpirationDate: Date yesterday
				belongingTo: 'Carlos Esteban Romenez Cerezo Cartesiano Di Cuore Chorizo' ]
		raise: Error
		withExceptionDo: [ :anError | self assert: anError messageText = Cashier aExpiredCreditCardCantBuyAnything ]! !

!TusLibrosTests methodsFor: 'as yet unclassified' stamp: 'EzequielBarrios 6/9/2013 22:48'!
test05AnExpiredCreditCardShouldRaiseAnError
	"No se puede cobrar a una tarjeta de crdito vencida."

	self
		should: [ 
			Cashier new
				checkOut: self aNonEmptyCart
				withCreditCard: 1000
				andExpirationDate: Date yesterday
				belongingTo: nil ]
		raise: Error
		withExceptionDo: [ :anError | self assert: anError messageText = Cashier aExpiredCreditCardCantBuyAnything ]! !

!TusLibrosTests methodsFor: 'as yet unclassified' stamp: 'EzequielBarrios 6/12/2013 11:36'!
test06CheckingOutANonEmptyCartShouldSaveTotalPrice
	"Al hacer checkout de un carrito con productos debo registrar en el libro de ventas el valor total de la venta"

	| aCashier |
	aCashier := Cashier create: self.
	aCashier
		checkOut: self aNonEmptyCart
		withCreditCard: 1000
		andExpirationDate: Date tomorrow
		belongingTo: 'juanete'.
	self assert: aCashier purchaseBook last total = 187.2! !

!TusLibrosTests methodsFor: 'as yet unclassified' stamp: 'EzequielBarrios 6/10/2013 18:26'!
test07CheckingOutANonEmptyCartShouldSendCorrectData
	"Al hacer checkout de un carrito con productos debo registrar en el libro de ventas el valor total de la venta"

	| aCashier |
	aCashier := Cashier create: self.
	aCashier
		checkOut: self aNonEmptyCart
		withCreditCard: 1000
		andExpirationDate: Date tomorrow
		belongingTo: 'Carlos Robertez'.! !

!TusLibrosTests methodsFor: 'MPInterface' stamp: 'EzequielBarrios 6/12/2013 11:16'!
test08AnMpInterfaceShouldBeReturnACorrectLink
	"comment stating purpose of message"

	| merchantP |
	merchantP := MPInterface create: self.
	merchantP charge: 1000 to: 'Juan Orlandez' withCreditCard: 400100 thatExpire: Date tomorrow.! !

!TusLibrosTests methodsFor: 'MPInterface' stamp: 'EzequielBarrios 6/12/2013 11:35'!
test09AnMpInterfaceShouldBeReturnACorrectLink
	"comment stating purpose of message"

	| merchantP |
	merchantP := MPInterface create: self.
	self should: [ 
		(merchantP charge: -1 to: 'Juan Orlandez' withCreditCard: 400100 thatExpire: Date tomorrow)]
		raise: Error 
		withExceptionDo: [ :anError | self assert: anError messageText = 'bad request' ]
	! !

!TusLibrosTests methodsFor: 'methods' stamp: 'EzequielBarrios 6/12/2013 12:08'!
validate: aLink

	(aLink size =  136) ifTrue: [self assert: aLink = 'https://merchant.com/debit?creditCardNumber=400100&creditCardExpiration=062013&creditCardOwner=JUAN%20ORLANDEZ&transactionAmount=1000.00'.
		^ 'OK3333']
	ifFalse: [(aLink size = 134) ifTrue: [ ^ '400 bad request' ].]! !
